Subject: bug#34943: 27.0.50; Tramp explicte-shell-file-name not work and not safe local variable

From: Michael Albinus <[email-masked]>
Date: Fri, 22 Mar 2019 15:13:16 +0100

Shuguang Sun <[email-masked]> writes:

> Hi,

> The recent change to Tramp for shell/explict shell has break the remote shell again. For example:
> - Tramp to a host
> - in a remote diretory, M-x shell
>   it raise the error message: env path/to/cmdproxy.exe can't be found
>   which looks tramp shell invoke the local shell, instead the remote shell
>
> I have the settings:
> ```
>   (connection-local-set-profile-variables
>    'remote-bash
>    '((explicit-shell-file-name . "/bin/bash")
>      (explicit-bash-args . ("-i"))
>      ))
>
>   (connection-local-set-profiles
>    '(:application tramp :protocol "plink" :user "user" :machine "host.com")
>    'remote-bash)
> ```
> In the previous version of tramp (about Feb), it will invoke the explicit-shell-file-name, instead of local cmdproxy.

If `explicit-shell-file-name' is given, it must have precedence. What
about the following patch to master:

*** /tmp/ediffWyfTux	2019-03-22 15:09:52.065151959 +0100
--- /home/albinus/src/emacs/lisp/shell.el	2019-03-22 15:09:35.080867417 +0100
***************
*** 721,729 ****
                   (current-buffer)))

    (with-current-buffer buffer
!     (when (file-remote-p default-directory)
!       ;; On remote hosts, the local `shell-file-name' might be useless.
!       (with-connection-local-variables
         (if (and (called-interactively-p 'any)
                  (null explicit-shell-file-name)
                  (null (getenv "ESHELL")))
--- 721,729 ----
                   (current-buffer)))

    (with-current-buffer buffer
!     (with-connection-local-variables
!      ;; On remote hosts, the local `shell-file-name' might be useless.
!      (when (file-remote-p default-directory)
         (if (and (called-interactively-p 'any)
                  (null explicit-shell-file-name)
                  (null (getenv "ESHELL")))
***************
*** 732,757 ****
  		 (expand-file-name
                    (read-file-name
                     "Remote shell path: " default-directory shell-file-name
!                    t shell-file-name))))))))

!   ;; The buffer's window must be correctly set when we call comint
!   ;; (so that comint sets the COLUMNS env var properly).
!   (pop-to-buffer buffer)
!   ;; Rain or shine, BUFFER must be current by now.
!   (unless (comint-check-proc buffer)
!     (let* ((prog (or explicit-shell-file-name
!                      (getenv "ESHELL") shell-file-name))
!            (name (file-name-nondirectory prog))
!            (startfile (concat "~/.emacs_" name))
!            (xargs-name (intern-soft (concat "explicit-" name "-args"))))
!       (unless (file-exists-p startfile)
!         (setq startfile (concat user-emacs-directory "init_" name ".sh")))
!       (apply #'make-comint-in-buffer "shell" buffer prog
!              (if (file-exists-p startfile) startfile)
!              (if (and xargs-name (boundp xargs-name))
!                  (symbol-value xargs-name)
!                '("-i")))
!       (shell-mode)))
    buffer)

  ;;; Directory tracking
--- 732,757 ----
  		 (expand-file-name
                    (read-file-name
                     "Remote shell path: " default-directory shell-file-name
!                    t shell-file-name))))))

!      ;; The buffer's window must be correctly set when we call comint
!      ;; (so that comint sets the COLUMNS env var properly).
!      (pop-to-buffer buffer)
!      ;; Rain or shine, BUFFER must be current by now.
!      (unless (comint-check-proc buffer)
!        (let* ((prog (or explicit-shell-file-name
!                         (getenv "ESHELL") shell-file-name))
!               (name (file-name-nondirectory prog))
!               (startfile (concat "~/.emacs_" name))
!               (xargs-name (intern-soft (concat "explicit-" name "-args"))))
!          (unless (file-exists-p startfile)
!            (setq startfile (concat user-emacs-directory "init_" name ".sh")))
!          (apply #'make-comint-in-buffer "shell" buffer prog
!                 (if (file-exists-p startfile) startfile)
!                 (if (and xargs-name (boundp xargs-name))
!                     (symbol-value xargs-name)
!                   '("-i")))
!          (shell-mode)))))
    buffer)

  ;;; Directory tracking

> Another issue, the emacs treat explicit-shell-file-name and explicit-bash-args as non-safe local variables and ask how to deal it (Y/N/! ...).
> In the previous version of tramp (about Feb), it takes these two variables as safe which I think is reasonable because user sets it in tramp-way explicitely and it is only used in tramp only.

I'll check when the first problem is solved.

Best regards, Michael.